Write an efficient program to find the sum of contiguous subarray within a one-dimensional array of numbers that has the largest sum.
Kadane’s Algorithm:
Initialize: max_so_far = INT_MIN max_ending_here = 0 Loop for each element of the array (a) max_ending_here = max_ending_here + a[i] (b) if(max_so_far < max_ending_here) max_so_far = max_ending_here (c) if(max_ending_here < 0) max_ending_here = 0 return max_so_far
Explanation:
The simple idea of Kadane’s algorithm is to look for all positive contiguous segments of the array (max_ending_here is used for this). And keep track of maximum sum contiguous segment among all positive segments (max_so_far is used for this). Each time we get a positive-sum compare it with max_so_far and update max_so_far if it is greater than max_so_far
Lets take the example: {-2, -3, 4, -1, -2, 1, 5, -3} max_so_far = max_ending_here = 0 for i=0, a[0] = -2 max_ending_here = max_ending_here + (-2) Set max_ending_here = 0 because max_ending_here < 0 for i=1, a[1] = -3 max_ending_here = max_ending_here + (-3) Set max_ending_here = 0 because max_ending_here < 0 for i=2, a[2] = 4 max_ending_here = max_ending_here + (4) max_ending_here = 4 max_so_far is updated to 4 because max_ending_here greater than max_so_far which was 0 till now for i=3, a[3] = -1 max_ending_here = max_ending_here + (-1) max_ending_here = 3 for i=4, a[4] = -2 max_ending_here = max_ending_here + (-2) max_ending_here = 1 for i=5, a[5] = 1 max_ending_here = max_ending_here + (1) max_ending_here = 2 for i=6, a[6] = 5 max_ending_here = max_ending_here + (5) max_ending_here = 7 max_so_far is updated to 7 because max_ending_here is greater than max_so_far for i=7, a[7] = -3 max_ending_here = max_ending_here + (-3) max_ending_here = 4
Program:
Javascript
<script> // JavaScript program to find maximum // contiguous subarray // Function to find the maximum // contiguous subarray function maxSubArraySum(a, size) { var maxint = Math.pow(2, 53) var max_so_far = -maxint - 1 var max_ending_here = 0 for ( var i = 0; i < size; i++) { max_ending_here = max_ending_here + a[i] if (max_so_far < max_ending_here) max_so_far = max_ending_here if (max_ending_here < 0) max_ending_here = 0 } return max_so_far } // Driver code var a = [ -2, -3, 4, -1, -2, 1, 5, -3 ] document.write( "Maximum contiguous sum is" , maxSubArraySum(a, a.length)) // This code is contributed by AnkThon </script> |
Output:
Maximum contiguous sum is 7
Another approach:
Javascript
<script> // JavaScript Program to implement // the above approach function maxSubarraySum(arr, size) { let max_ending_here = 0, max_so_far = Number.MIN_VALUE; for (let i = 0; i < size; i++) { // include current element to previous subarray only // when it can add to a bigger number than itself. if (arr[i] <= max_ending_here + arr[i]) { max_ending_here += arr[i]; } // Else start the max subarray from current element else { max_ending_here = arr[i]; } if (max_ending_here > max_so_far) { max_so_far = max_ending_here; } } return max_so_far; } // This code is contributed by Potta Lokesh </script> |
Time Complexity: O(n)
Algorithmic Paradigm: Dynamic Programming
Following is another simple implementation suggested by Mohit Kumar. The implementation handles the case when all numbers in the array are negative.
Javascript
<script> // C# program to print largest // contiguous array sum function maxSubArraySum(a,size) { let max_so_far = a[0]; let curr_max = a[0]; for (let i = 1; i < size; i++) { curr_max = Math.max(a[i], curr_max+a[i]); max_so_far = Math.max(max_so_far, curr_max); } return max_so_far; } // Driver code let a = [-2, -3, 4, -1, -2, 1, 5, -3]; let n = a.length; document.write( "Maximum contiguous sum is " ,maxSubArraySum(a, n)); </script> |
Output:
Maximum contiguous sum is 7
To print the subarray with the maximum sum, we maintain indices whenever we get the maximum sum.
Javascript
<script> // javascript program to print largest // contiguous array sum function maxSubArraySum(a , size) { var max_so_far = Number.MIN_VALUE, max_ending_here = 0, start = 0, end = 0, s = 0; for (i = 0; i < size; i++) { max_ending_here += a[i]; if (max_so_far < max_ending_here) { max_so_far = max_ending_here; start = s; end = i; } if (max_ending_here < 0) { max_ending_here = 0; s = i + 1; } } document.write( "Maximum contiguous sum is " + max_so_far); document.write( "<br/>Starting index " + start); document.write( "<br/>Ending index " + end); } // Driver code var a = [ -2, -3, 4, -1, -2, 1, 5, -3 ]; var n = a.length; maxSubArraySum(a, n); // This code is contributed by Rajput-Ji </script> |
Output:
Maximum contiguous sum is 7 Starting index 2 Ending index 6
Kadane’s Algorithm can be viewed both as a greedy and DP. As we can see that we are keeping a running sum of integers and when it becomes less than 0, we reset it to 0 (Greedy Part). This is because continuing with a negative sum is way more worse than restarting with a new range. Now it can also be viewed as a DP, at each stage we have 2 choices: Either take the current element and continue with previous sum OR restart a new range. These both choices are being taken care of in the implementation.
Time Complexity: O(n)
Auxiliary Space: O(1)
Now try the below question
Given an array of integers (possibly some elements negative), write a C program to find out the *maximum product* possible by multiplying ‘n’ consecutive integers in the array where n ≤ ARRAY_SIZE. Also, print the starting point of the maximum product subarray.
Please refer complete article on Largest Sum Contiguous Subarray for more details!
Ready to dive in? Explore our Free Demo Content and join our DSA course, trusted by over 100,000 neveropen!